package com.lamark.business.bemobi.core.client;

import com.lamark.architecture.corems.exception.BaseException;
import com.lamark.architecture.corems.exception.BaseRuntimeException;
import com.lamark.core.dto.SubscriptionDataDto;
import com.lamark.core.dto.SubscriptionDto;
import org.eclipse.microprofile.rest.client.inject.RegisterRestClient;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

@RegisterRestClient(configKey = "business-command")
@Path("/business/v1/command")
public interface BusinessCommandClient {

    @PUT
    @Produces(MediaType.APPLICATION_JSON)
    @Path("/subscribe")
    Response subscribe(SubscriptionDto subscriptionDto) throws  BaseException;

    @PUT
    @Path("/renew")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    Response renew(SubscriptionDataDto data);

    @PUT
    @Path("/cancel/{msisdn}/{site}/{cancelationType}")
    @Produces(MediaType.APPLICATION_JSON)
    Response cancel(@PathParam("msisdn") String msisdn, @PathParam("site") Integer site,
                           @PathParam("cancelationType" ) String eventType) throws BaseException ;

    @PUT
    @Path("/suspend/{msisdn}/{site}/{suspendType}")
    @Produces(MediaType.APPLICATION_JSON)
    Response suspend(@PathParam("msisdn") String msisdn,
                            @PathParam("site") Integer site,
                            @PathParam("suspendType" ) String eventType ) throws BaseException;
}
