package com.lamark.business.bemobi.core.client;

import com.lamark.core.dto.SubscriptionBemobiDto;
import org.eclipse.microprofile.rest.client.inject.RegisterRestClient;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Response;

@RegisterRestClient(configKey="data-bemobi")
@Path("/data/v1/bemobi")
public interface DataBemobiSubscriptionClient {

    @GET
    @Path("/findByUserAndSubscription")
    SubscriptionBemobiDto findByUserAndSubscription(@QueryParam("opxUserID")
                                                                   String opxUserID, @QueryParam("opxSubscriptionID") String opxSubscriptionID) ;
    @GET
    @Path("/findByProviderUniqueId")
    SubscriptionBemobiDto findByProviderUniqueId(@QueryParam("findByProviderUniqueId" ) String findByProviderUniqueId);

    @POST
    @Path("/subscription")
    Response saveSubscription(SubscriptionBemobiDto dto);

    @PUT
    @Path("/subscription")
    SubscriptionBemobiDto updateSubscription(@QueryParam("opxUserID") String opxUserID,
                                                    @QueryParam("opxSubscriptionID") String opxSubscriptionID,
                                                    SubscriptionBemobiDto dto);
}
